function phi3 = calcPhi3(knots,x),

t2=knots(2);
t3=knots(3);
t4=knots(4);


A=[3*t2^2 2*t2 1 0 0 0 0 0
    t2^3 t2^2 t2 1 0 0 0 0
    t4^3 t4^2 t4 1 0 0 0 0
    0 0 0 0 t4^3 t4^2 t4 1
    3*t4^2 2*t4 1 0 0 0 0 0
    0 0 0 0 3*t4^2 2*t4 1 0
    0 0 0 0 3*(2*t4-t2)^2 2*(2*t4-t2) 1 0
    0 0 0 0 (2*t4-t2)^3 (2*t4-t2)^2 (2*t4-t2) 1];
    
%Solving Ax=B
B=[0;0;1e-3;1e-3;0;0;0;0];

coeffs=inv(A)*B;
a=coeffs(1);
b=coeffs(2);
c=coeffs(3);
d=coeffs(4);
e=coeffs(5);
f=coeffs(6);
g=coeffs(7);
h=coeffs(8);


phi3=zeros(size(x));
zeropart1 = find(x<t2);
cubpart1 = find(x>=t2&x<t4);
cubpart2 = find(x>=t4&x<2*t4-t2);
zeropart2=find(x>=2*t4-t2);

phi3(zeropart1)=0;
phi3(cubpart1)=a*x(cubpart1).^3+b*x(cubpart1).^2+c*x(cubpart1)+repmat(d,size(x(cubpart1)));
phi3(cubpart2)=e*x(cubpart2).^3+f*x(cubpart2).^2+g*x(cubpart2)+repmat(h,size(x(cubpart2)));
phi3(zeropart2)=0;

