%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Init file for controller
%
% Erlend Helgeland 15.02.08
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fprintf('--------- Start of control_init.m ---------\n');

%pd%Calculate PD controller gain

%Lure&bra:
Kp = 5.1e-2%6.4e-2;%Control gain 
Td = 2.4e-2;%Derivative time%Greit utan sty
alpha_pd=0.05;%Limitaion on D-effect

sliding_mode%Sliding mode controller

%Pressure estimate
D_vs_est = 5000;%Viscous friction in the pressure estimate
f_l_gain_est = 1;%Clutch load force gain
y_dev_est = 0;%Clutch load shift
const_pressure = 4e5;%Constant pressure value
pressure_switch = 0;

%Weights for w_d
weights_w_d = [4 3 2 1 1/2 1/4 1/8 1/16 1/32 1/64];%ones(1,10);%[4 3 2 1 1/2 1/4 1/8 1/16 1/32 1/64];%ones(1,10);%[2 1.9 1.8 1.7 1.6 1.5 1.4 1.3 1.2 1.1];
weights_sum = sum(weights_w_d);


%Control disengage block parameters
open_time = 0.7;%[s] Opening time for valves
y_threshold = 0.002+y_dev;%[m]
y_d_threshold = 0.002;%[m]
v_d_threshold = 0.02;%[m/s]

%Reference trajectory
a_0 = 70;%Poles at -a_0
m_0 = a_0^5;
m_1 = 5*a_0^4;
m_2 = 10*a_0^3;
m_3 = 10*a_0^2;
m_4 = 5*a_0;

%Relax valves

fprintf('--------- End of control_init.m ---------\n');