% Find a new variable in the current workspace after a matfile is loaded.
%
% [newVariable] = findVariableInMatFile(matFile)
% where newVariable is a textstring.
%
function [newVariable] = findVariableInMatFile(matFile)



oldVarList = 'Dummy';    % Create this variable, so we dont detect it as new.
oldVarList = who;
eval(['load ' matFile '.mat'])      % loads log file

newVarList = who;

newVariable = '';
for i = 1:length(newVarList)
    foundVar = 0;
    for j = 1:length(oldVarList)
       if findstr(cell2mat(newVarList(i)),cell2mat(oldVarList(j))) == 1 
           foundVar = 1;
           break;
       end
    end
    if foundVar == 0
        newVariable = cell2mat(newVarList(i));
        break;
    end
end

