%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Spring estimate using model of Hege Langjord
%
%Erlend Helgeland
%03.05.2008
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all
%
scrsz = get(0,'ScreenSize');%Get screen size for plots

[X,Y] = assignVar('dc0p1','_data');%Import measurement data
eval(Y);

pos=0:(0.025-0)/(1000-1):0.025;%Interval for spring calculation and plotting

knots =[0 2 8.5 11.5];%[mm]
theta_l = [8.2850e5 -0.1824e5 6.1399e5];%Ballistic estimation
phi_l=makephis(knots);%Calculate clutch load basis functions
f_l = theta_l*phi_l;%Spring force
dphi_l=dmakephis(knots);%Calculate clutch basis functions derivative
df_l =theta_l*dphi_l;%Spring force differentiatied wrt y

Mphi_l = [pos; f_l];%Preparation for lookup table

dMphi_l = [pos; df_l];%Preparation for lookup table
%{
figure('Position',[100 100 scrsz(3)/2+100 1.5*scrsz(4)/2])%subplot(31n)-mal 
subplot(311)
hold on
title('Clutch load characteristic')
xlabel('Clutch actuator position [m]')
ylabel('Spring force [N]')
plot(y_m_data,A_A.*(p_m_data-P_0),':','MarkerSize',1,'Color',[0.4 0.4 0.4]);%Plot spring force vs position
plot(pos,f_l,'k');
axis([-0.0005 0.025 -200 5000]);
legend('Measurement','Fitted model');
grid
hold off

subplot(312)
hold on
title('Clutch load characteristic derivative')
xlabel('Clutch actuator position [m]')
ylabel('Spring force slope [N/m]')
plot(pos,df_l,'k');%Plot spring force derivative vs position
axis([-0.0005 0.025 -1.5e5 8.5e5])
grid
hold off

subplot(313)
plot(pos,phi_l);
axis([-0.0005 0.025 0 0.025])
title('Basis functions')
xlabel('Position [m]')
grid
%}