%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PD controller design
%
% Erlend Helgeland
% 03.26.08
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fprintf('--------- Start of pd.m ---------\n');
close all

y_star =7.5e-3;%[m] linearization point
T_0 = 293;%[K] Initial/environmental temperature
V_A0 = 1.48e-4;%[m^3] (KA), initial volume chamber A
r_act = (0.125/2);%[m] Actuator piston radius
M = 10;%[kg] Equivalent mass actuator
R = 287.05;%[J/(kgK)] Dry air gas constant (Gjone: 288 J/KgK)
A_A = pi*r_act^2;%[m^2] Actuator piston area, side A
V_y_star = V_A0+A_A*y_star;
q_star = 111.6061;%[JKkg^2]
%f_lstar=8.2850e5*(-76.92308*y_star^2+1.3077*y_star-3.0769e-4) -0.1824e5*(7.6923e-2*y_star^2-3.0769e-4*y_star-3.0769e-7)+6.1399e5*(-2.3327e3*y_star^3 +47.2372*y_star^2-0.1610*y_star-1.5163e-4);
%df_lstar=8.2850e5*(-76.92308*2*y_star+1.3077) -0.1824e5*(7.6923e-2*2*y_star-3.0769e-4)+6.1399e5*(-2.3327e3*3*y_star^2 +47.2372*2*y_star-0.1610);
f_lstar = 4.7888e3;
df_lstar = 5.7358e4;
%{
%Bra:
Kp = 8e-2;%Control gain 
Td = 2e-2;%Derivative time%Greit utan sty
alpha_pd=0.5;%Limitaion on D-effect
%}

%Lure&bra:
Kp = 5.1e-2%6.4e-2;%Control gain 
Td = 2.4e-2;%Derivative time%Greit utan sty
alpha_pd=0.05;%Limitaion on D-effect

%Scaled system
%New linearization point
y_star = y_star*1e2;%[m]->[cm]
%v_star is unchanged
p_star = 4.6495;%[bar]
v_star = 0;
%{
A_pd = [0 100 0; -1e-2*df_lstar/M -5000/M 1e5*A_A/M; 0 -(A_A/V_y_star)*p_star 0]
B_pd = [0; 0; 1e-5*R*T_0/V_y_star]
C_pd = [1e-2 0 0]%position measurement is [m] x_1 given in [cm]
D_pd = [0]
%}
%}
[num_d,den_d]=pade(5e-3,2);%Time delay, second order Pad-approximation
%From Maple
transferf = tf([0 0 0 4.3e7*num_d(1) 4.3e7*num_d(2) 4.3e7*num_d(3)],[1*den_d(1) 1*den_d(2)+500*den_d(1) 1*den_d(3)+500*den_d(2)+34906*den_d(1) 500*den_d(3)+34906*den_d(2)+0 34906*den_d(3)+0 0])


e=num_d(1);
f=num_d(2);
g=num_d(3);

e2=den_d(1);
f2=den_d(2);
g2=den_d(3);

a=0;
b=0;
c=0;
d=4.3e7*Kp*Td;
j=4.3e7*Kp;

a2=alpha_pd*Td;
b2=1+500*alpha_pd*Td;
c2=500+34906*alpha_pd*Td;
d2=34906;
j2=0;

transferf_reg = tf([a*e (a*f+b*e) (a*g+b*f+c*e) (b*g+c*f+d*e) (c*g+d*f+j*e) (d*g+j*f) j*g],[a2*e2 (a2*f2+b2*e2) (a2*g2+b2*f2+c2*e2) (b2*g2+c2*f2+d2*e2) (c2*g2+d2*f2+j2*e2) (d2*g2+j2*f2) j2*g2]);%[alpha_pd*Td  (1+500*alpha_pd*Td) (500+34906*alpha_pd*Td) 34906 0])
figure(1)
bode(transferf,'k');
grid
figure(2)
margin(transferf_reg)

%grid
%{
%Closed loop poles
poles = zeros(3,length(Mphi_l));
for i=1:1:length(Mphi_l)
    A_pd = [0 1000 0; -1e-3*dMphi_l(2,i)/M -5000 1e5*A_A/M; 0 -(A_A/(V_A0+A_A*y_star))*p_star 0];
    B_pd = [0; 0; 1e-5*R*T_0/(V_A0+A_A*Mphi_l(1,i))];
    poles(:,i)=eig(A_pd-B_pd*[Kp*1e-3 Kp*Td 0]);
end
%plot(Mphi_l(1,:),abs(poles));%,poles(2,:),Mphi_l(1,:),poles(3,:));
figure('Position',[100 100 scrsz(3)/2+100 1.5*scrsz(4)/2])%subplot(31n)-mal 
title('Closed loop poles');
subplot(3,1,[1 2])
    %hold on
    %for i=1:1:length(poles)
     %   plot(poles(1,i),'k')
    %end
    plot(real(poles(1,:)),imag(poles(1,:)),'k')
    grid
    xlabel('Re');
    ylabel('Im');
    hold on
    plot(real(poles(2,:)),imag(poles(2,:)),'k')
    axis on
subplot(313)
    plot(Mphi_l(1,:),poles(3,:),'k')
    grid
    xlabel('Position [m]')
%}
fprintf('--------- End of pd.m ---------\n');